Attribute VB_Name = "mMain"
Option Explicit

Rem ***************************************************************************
Rem * A Simple 'Click'n'Destroy' Demonstration in Window Mode                 *
Rem ***************************************************************************


Public bRunning     As Boolean
Private gfxBack     As typeGFX_HBM          ' sprite object
Private gfxShot     As typeGFX_HBM          ' sprite object
Private gfxAim      As typeGFX_HBM          ' sprite object
Private sndZwuk     As stSoundBuffer        ' sound object
Private mouse       As clsMouse             ' mouse class
Private rEmpty      As RECT

Sub Main()


 bRunning = True
 
 ' otvori log-file / open log file
 Call mUtil.OpenLog(App.Path)
 ' inicializira DirectX class-a / Init DX
 Call mDirectDraw.DXInit
 ' inicializira directdraw / Init DirectDraw
 Call mDirectDraw.DDInit(frmMain.hwnd, 640, 480, 16, True)
 ' inicializra directsound / Init DirectSound
 Call mDirectSound.DSInit(frmMain.hwnd)
 ' inicializira directInput / Init DirectInput for Keyboard and Mouse
 Call mDirectInput.DIInit(frmMain.hwnd, DI_KEYBOARD Or DI_MOUSE)
 
 ' podgotvi mouse class-a / setup mouse class
 Set mouse = New clsMouse
 Call mouse.SaveCoords
 ' API na class-a / Mouse API class  - > (DirectInput or win32)
 mouse.SetMouseInput = MI_API
 mouse.SetCursorHeight = 25
 mouse.SetCursorWidth = 25
 Call mouse.Acquire
 
 ' ----------- load ---------
 ' zaredi nqkakwa kartinka ( s auto opredelqne na goleminata i pozrachen cwqt = 0 )
 ' -1 -> set the transparent color automaticalyl ( assumes pixel at positoin 1,1 )
 gfxShot = mDirectDraw.CreateGFX_HBM(App.Path & "\shot1.bmp", 0&, 0&, True, -1)
 gfxAim = mDirectDraw.CreateGFX_HBM(App.Path & "\aim.bmp", 0&, 0&, True, 0&)
 gfxBack = mDirectDraw.CreateGFX_HBM(App.Path & "\back.bmp", 0&, 0&, True, -1)
 ' load sound / zaredi zwuk
 Call mDirectSound.DSCreateSound(sndZwuk, 3, LS_FROMFILE, App.Path & "\bexp.wav")
 ' --------------------------
 
 ' pokaji formata / show game-form
 frmMain.Show
 
 
 Do While (bRunning)
   
   ' izchisti backbufera s cvqt / clear backbuffer with default color
   mGFX.GFXClearBackBuffer (RGB(25, 125, 25))
   
   ' proveri za natisnati kopcheta i za actions na mishkata / check for keyboard pressings
   mDirectInput.DICheckKeys
   ' refresh mouse position and actions
   mouse.GetActions
           
   ' blitni paravan / blit blank screen
   mGFX.BltFastGFX_HBM 0, 0, gfxBack
           
   ' blitni kartinkata na kursora / blit cursor
   mGFX.BltFastGFX_HBM mouse.GetX, mouse.GetY, gfxAim
   
   ' proverka za natisnat lqv buton na mishkata / check if mouse-left was pressed
   If (mouse.GetLeft = MS_Up) Then
    ' mojete syshto taka mnogo lesno da poluchite dostyp direktno do DD surface
    ' you can easily access the DirectDraw surface with the typeGFX_HBM structure
    ' and write directly to it using DirectDraw functions
    gfxBack.dds.BltFast mouse.GetX - gfxShot.cx / 2, mouse.GetY - gfxShot.cy / 2, _
                gfxShot.dds, rEmpty, DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
    ' pusniq zvuk / play sound
    mDirectSound.DSPlaySound sndZwuk, False
   End If
     
   
   ' izchakai refrsh rate-a na monitora / wait for retrace
   Do While lpDD.WaitForVerticalBlank(DDWAITVB_BLOCKEND, 0) <> DD_OK
   Loop
         
   ' ostavi windowz da si wika raznite bokluci ;) / let windows do its stuff
   DoEvents
   ' razmeni buferite / flip buffers
   mDirectDraw.DDBlitToPrim
 Loop
 
 ' zatvori wsi4ko / close all
 Call ReleaseAll

End Sub


' procedura za greshki ( i zatvarqne )
Public Sub _
MakeError(lpStr As String)
  Call MsgBox(lpStr, vbExclamation, "What the...")
  Call ReleaseAll
End Sub


' procedura za greshki
Public Sub _
ErrorMsg(lpStr As String)
 Call MsgBox(lpStr, vbCritical)
End Sub


' zatvarq wsichko / close our program
Public Sub ReleaseAll()
 On Local Error Resume Next

 
 AppendToLog (LOG_DASH)
 AppendToLog ("Unloading ...")

 AppendToLog ("Closing DirectX")
 ' vyrni startiq grafichen rejim i directx clasovete
 Call DDRestoreModes(frmMain.hwnd)
 
 Call DDReleaseGFX_HBM(gfxShot)
 Call DDReleaseGFX_HBM(gfxAim)
 Call DDReleaseGFX_HBM(gfxBack)
 Call DSReleaseSound(sndZwuk)
 
 Call DDRelease
 Call DSRelease
 Call DIRelease
 Call DXRelease
 
 ' zatvori loga
 Call CloseLog
 
 End
 
End Sub


