Attribute VB_Name = "mDirectMusic"
Option Explicit

Dim lpDX As New DirectX7
Dim lpDMLoader As DirectMusicLoader
Dim lpDMPerf As DirectMusicPerformance
Dim lpDMPerf2 As DirectMusicPerformance
Dim lpDMSegment As DirectMusicSegment
Dim lpDMSegState As DirectMusicSegmentState
Dim bInitSuccessful As Boolean

Public Function DM_Init(hWnd As Long) As Boolean
 On Local Error GoTo DMError
 
 ' reset function return value
 DM_Init = False
 ' create the loader and performance objects
 Set lpDMLoader = lpDX.DirectMusicLoaderCreate()
 Set lpDMPerf = lpDX.DirectMusicPerformanceCreate()
 Set lpDMPerf2 = lpDX.DirectMusicPerformanceCreate()
 
 ' hWnd is the window handle of the main form
 ' setup 1st perf
 Call lpDMPerf.Init(Nothing, hWnd)
 Call lpDMPerf.SetPort(-1, 80)
 Call lpDMPerf.SetMasterAutoDownload(True)
 ' setup 2nd perf
 Call lpDMPerf2.Init(Nothing, 0)
 Call lpDMPerf2.SetPort(-1, 80)
 Call lpDMPerf2.SetMasterAutoDownload(True)
 
 bInitSuccessful = True
 DM_Init = True
Exit Function

DMError:  'ErrorMsg ("Error initializing DirectMusic!")
         bInitSuccessful = False
         DM_Init = False
End Function

Public Sub DM_Load(lpFileName As String)
 On Local Error GoTo DDError
 If bInitSuccessful = False Then Exit Sub
 
 ' clear segment objects
 Set lpDMSegment = Nothing
 Set lpDMSegState = Nothing
 ' load file
 Set lpDMSegment = lpDMLoader.LoadSegment(lpFileName)
 ' see if it's true midi and adjust handling
 If StrConv(Right(lpFileName, 4), vbLowerCase) = ".mid" Then
    lpDMSegment.SetStandardMidiFile
 End If
 
 lpDMSegment.SetStartPoint 0
Exit Sub

DDError: ' ErrorMsg ("Error loading file!")

End Sub

Public Sub DM_Play(Optional lPos As Integer = 0)
 On Local Error GoTo DDError
 If bInitSuccessful = False Then Exit Sub
 
 Call lpDMSegment.SetStartPoint(lPos)
 Set lpDMSegState = lpDMPerf.PlaySegment(lpDMSegment, 0, 0)
Exit Sub

DDError: ' ErrorMsg ("Error playing file!")
           
End Sub

Public Sub DM_Stop()
 If bInitSuccessful = False Then Exit Sub
 Call lpDMPerf.Stop(lpDMSegment, lpDMSegState, 0, 0)
End Sub

Public Sub DM_SetVolume(nVol As Integer)
 If bInitSuccessful = False Then Exit Sub
 Call lpDMPerf.SetMasterVolume(nVol)
End Sub

Public Function DM_GetVolume() As Integer
 If bInitSuccessful = False Then Exit Function
 DM_GetVolume = lpDMPerf.GetMasterVolume
End Function

Public Sub DM_SetTempo(fTempo As Single)
 If bInitSuccessful = False Then Exit Sub
 ' default is 1, 0.5 half, 2.0 fast & etc.
 Call lpDMPerf.SetMasterTempo(fTempo)
End Sub

Public Function DM_GetTempo() As Single
 If bInitSuccessful = False Then Exit Function
 DM_GetTempo = lpDMPerf.GetMasterTempo
End Function

Public Sub DM_Release()                             ' release all objects

 Set lpDMLoader = Nothing
 Set lpDMPerf = Nothing
 Set lpDMPerf2 = Nothing
 Set lpDMSegment = Nothing
 Set lpDMSegState = Nothing
 bInitSuccessful = False
End Sub

