Attribute VB_Name = "mMain"
Option Explicit

Rem ***************************************************************************
Rem * Example 2: - 'Desert Attack'                                            *
Rem ***************************************************************************


Public bRunning     As Boolean
Private gfxBack     As typeGFX_HBM          ' sprite object
Private gfxTile     As typeGFX_HBM          ' tile
Private gfxShip     As typeGFX_HBM          ' ship sprite
Private gfxShipShad As typeGFX_HBM          ' ship shadow
Private sndZwuk     As stSoundBuffer        ' sound object
Private mouse       As clsMouse             ' mouse class
Private rEmpty      As RECT

Sub Main()


 bRunning = True
 
 Call mUtil.OpenLog(App.Path)
 Call mDirectDraw.DXInit
 Call mDirectDraw.DDInit(frmMain.hWnd, 800, 600, 16, False)
 Call mDirectSound.DSInit(frmMain.hWnd)
 Call mDirectInput.DIInit(frmMain.hWnd, DI_KEYBOARD Or DI_MOUSE)
 
 ' init DirectMusic
 Call mDirectMusic.DM_Init(frmMain.hWnd)
 
 ' setup mouse class
 Set mouse = New clsMouse
 Call mouse.SaveCoords
 mouse.SetMouseInput = MI_DI
 mouse.HideCursor = True
 mouse.SetCursorHeight = 25
 mouse.SetCursorWidth = 25
 Call mouse.Acquire
 
 ' ----------- load ---------
 ' zaredi nqkakwa kartinka ( s auto opredelqne na goleminata i pozrachen cwqt = 0 )
 ' -1 -> set the transparent color automaticalyl ( assumes pixel at positoin 1,1 )
 gfxBack = mDirectDraw.CreateGFX_HBM(App.Path & "\back.bmp", 0&, 0&, True, -1)
 gfxTile = mDirectDraw.CreateGFX_HBM(App.Path & "\tile.bmp", 0&, 0&, False)
 gfxShip = mDirectDraw.CreateGFX_HBM(App.Path & "\nw.bmp", 0&, 0&, True, 0&)
 gfxShipShad = mDirectDraw.CreateGFX_HBM(App.Path & "\nw.bmp", 0&, 0&, True, 0&)
 mGFX.CreateShadow gfxShipShad.dds
 ' load music
 mDirectMusic.DM_Load (App.Path & "\mus.mid")
 ' --------------------------
 
 ' show game-form
 frmMain.Show
 
 ' play music
 mDirectMusic.DM_Play
 
 Do While (bRunning)
   
   mGFX.GFXClearBackBuffer (RGB(25, 125, 25))
   mDirectInput.DICheckKeys
   mouse.GetActions
           
   Call UpdateFrame
        
   
   Do While lpDD.WaitForVerticalBlank(DDWAITVB_BLOCKEND, 0) <> DD_OK
   Loop
        
  
   DoEvents
   mDirectDraw.DDBlitToPrim
 Loop
 
 ' close all
 Call ReleaseAll

End Sub


Private Sub UpdateFrame()

   Dim i As Long, j As Long

   ' blit tile terrain
   For j = 0 To 10
    For i = 0 To 12
       mGFX.BltFastGFX_HBM i * 64, j * 64, gfxTile
    Next
   Next

   ' blit ship
   mGFX.BltFastGFX_HBM mouse.GetX + 15, mouse.GetY + 35, gfxShipShad
   mGFX.BltFastGFX_HBM mouse.GetX, mouse.GetY, gfxShip
        

End Sub


' procedura za greshki ( i zatvarqne )
Public Sub _
MakeError(lpStr As String)
  Call MsgBox(lpStr, vbExclamation, "What the...")
  Call ReleaseAll
End Sub


' procedura za greshki
Public Sub _
ErrorMsg(lpStr As String)
 Call MsgBox(lpStr, vbCritical)
End Sub


' zatvarq wsichko / close our program
Public Sub ReleaseAll()
 On Local Error Resume Next

 ' show back cursor
 mouse.HideCursor = False
 
 AppendToLog (LOG_DASH)
 AppendToLog ("Unloading ...")

 AppendToLog ("Closing DirectX")
 Call DDRestoreModes(frmMain.hWnd)
 
 Call DDReleaseGFX_HBM(gfxBack)
 Call DDReleaseGFX_HBM(gfxTile)
 Call DDReleaseGFX_HBM(gfxShip)
 
 Call DDRelease
 Call DSRelease
 Call DIRelease
 Call DXRelease
 
 ' zatvori loga
 Call CloseLog
 
 End
 
End Sub


